! prng_class.f90 --
!     Module defining the generic type for pseudo-random number
!     generators (PRNG). Used by all specific PRNG implementations
!
module prng_class
    implicit none

    type, abstract :: prng
        ! No data
    contains
        procedure(get_next), deferred :: get
    end type

    abstract interface
        real function get_next( params )
            import :: prng
            class(prng) :: params
        end function get_next
    end interface

end module prng_class
